Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.beans.factory
Interface ListableBeanFactory

All Superinterfaces:
  BeanFactory

All Known Subinterfaces:
  ApplicationContext, ConfigurableApplicationContext, ConfigurableListableBeanFactory, ConfigurablePortletApplicationContext, ConfigurableWebApplicationContext, WebApplicationContext

All Known Implementing Classes:
  AbstractApplicationContext, AbstractRefreshableApplicationContext, AbstractRefreshableConfigApplicationContext, AbstractRefreshablePortletApplicationContext, AbstractRefreshableWebApplicationContext, AbstractXmlApplicationContext, AnnotationConfigApplicationContext, AnnotationConfigWebApplicationContext, ClassPathXmlApplicationContext, DefaultListableBeanFactory, FileSystemXmlApplicationContext, GenericApplicationContext, GenericWebApplicationContext, GenericXmlApplicationContext, ResourceAdapterApplicationContext, StaticApplicationContext, StaticListableBeanFactory, StaticPortletApplicationContext, StaticWebApplicationContext, XmlBeanFactory, XmlPortletApplicationContext, XmlWebApplicationContext

    public interface ListableBeanFactory

extends BeanFactory

Extension of the `BeanFactory` interface to be implemented by bean factories that can enumerate all their bean instances, rather than attempting bean lookup by name one by one as requested by clients. BeanFactory implementations that preload all their bean definitions (such as XML-based factories) may implement this interface.

If this is a `HierarchicalBeanFactory`, the return values will not take any BeanFactory hierarchy into account, but will relate only to the beans defined in the current factory. Use the `BeanFactoryUtils` helper class to consider beans in ancestor factories too.

The methods in this interface will just respect bean definitions of this factory. They will ignore any singleton beans that have been registered by other means like `ConfigurableBeanFactory`'s `registerSingleton` method, with the exception of `getBeanNamesOfType` and `getBeansOfType` which will check such manually registered singletons too. Of course, BeanFactory's `getBean` does allow transparent access to such special beans as well. However, in typical scenarios, all beans will be defined by external bean definitions anyway, so most applications don't need to worry about this differentation.

NOTE: With the exception of `getBeanDefinitionCount` and `containsBeanDefinition`, the methods in this interface are not designed for frequent invocation. Implementations may be slow.

Since:
  16 April 2001
Author:
  Rod Johnson, Juergen Hoeller
See Also:
  `HierarchicalBeanFactory`, `BeanFactoryUtils`

Field Summary

Fields inherited from interface org.springframework.beans.factory.BeanFactory
`FACTORY_BEAN_PREFIX`

Method Summary
`boolean` | `containsBeanDefinition(java.lang.String beanName)` Check if this bean factory contains a bean definition with the given name.
`
`<A extends java.lang.annotation.Annotation> A`
` | `findAnnotationOnBean(java.lang.String beanName, java.lang.Class<A> annotationType)` Find a `Annotation` of `annotationType` on the specified bean, traversing its interfaces and super classes if no annotation can be found on the given class itself.
`int` | `getBeanDefinitionCount()` Return the number of beans defined in the factory.
`java.lang.String[]` | `getBeanDefinitionNames()` Return the names of all beans defined in this factory.
`java.lang.String[]` | `getBeanNamesForType(java.lang.Class<?> type)` Return the names of beans matching the given type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.
`java.lang.String[]` | `getBeanNamesForType(java.lang.Class<?> type, boolean includeNonSingletons, boolean allowEagerInit)` Return the names of beans matching the given type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.
`
`<T> java.util.Map<java.lang.String,T>`
` | `getBeansOfType(java.lang.Class<T> type)` Return the bean instances that match the given object type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.
`
`<T> java.util.Map<java.lang.String,T>`
` | `getBeansOfType(java.lang.Class<T> type, boolean includeNonSingletons, boolean allowEagerInit)` Return the bean instances that match the given object type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.
`java.util.Map<java.lang.String,java.lang.Object>` | `getBeansWithAnnotation(java.lang.Class<? extends java.lang.annotation.Annotation> annotationType)` Find all beans whose `Class` has the supplied `Annotation` type.

Methods inherited from interface org.springframework.beans.factory.BeanFactory
`containsBean, getAliases, getBean, getBean, getBean, getBean, getType, isPrototype, isSingleton, isTypeMatch`

Method Detail

### containsBeanDefinition

    boolean containsBeanDefinition(java.lang.String beanName)

  Check if this bean factory contains a bean definition with the given name.

  Does not consider any hierarchy this factory may participate in, and ignores any singleton beans that have been registered by other means than bean definitions.

  Parameters:
    `beanName` - the name of the bean to look for
  Returns:
    if this bean factory contains a bean definition with the given name
  See Also:
    `BeanFactory.containsBean(java.lang.String)`

### getBeanDefinitionCount

    int getBeanDefinitionCount()

  Return the number of beans defined in the factory.

  Does not consider any hierarchy this factory may participate in, and ignores any singleton beans that have been registered by other means than bean definitions.

  Returns:
    the number of beans defined in the factory

### getBeanDefinitionNames

    java.lang.String[] getBeanDefinitionNames()

  Return the names of all beans defined in this factory.

  Does not consider any hierarchy this factory may participate in, and ignores any singleton beans that have been registered by other means than bean definitions.

  Returns:
    the names of all beans defined in this factory, or an empty array if none defined

### getBeanNamesForType

    java.lang.String[] getBeanNamesForType(java.lang.Class<?> type)

  Return the names of beans matching the given type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.

  NOTE: This method introspects top-level beans only. It does not check nested beans which might match the specified type as well.

  Does consider objects created by FactoryBeans, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type.

  Does not consider any hierarchy this factory may participate in. Use BeanFactoryUtils' `beanNamesForTypeIncludingAncestors` to include beans in ancestor factories too.

  Note: Does not ignore singleton beans that have been registered by other means than bean definitions.

  This version of `getBeanNamesForType` matches all kinds of beans, be it singletons, prototypes, or FactoryBeans. In most implementations, the result will be the same as for `getBeanNamesOfType(type, true, true)`.

  Bean names returned by this method should always return bean names in the order of definition in the backend configuration, as far as possible.

  Parameters:
    `type` - the class or interface to match, or `null` for all bean names
  Returns:
    the names of beans (or objects created by FactoryBeans) matching the given object type (including subclasses), or an empty array if none
  See Also:
    `FactoryBean.getObjectType()`, `BeanFactoryUtils.beanNamesForTypeIncludingAncestors(ListableBeanFactory, Class)`

### getBeanNamesForType

    java.lang.String[] getBeanNamesForType(java.lang.Class<?> type,
                                           boolean includeNonSingletons,
                                           boolean allowEagerInit)

  Return the names of beans matching the given type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.

  NOTE: This method introspects top-level beans only. It does not check nested beans which might match the specified type as well.

  Does consider objects created by FactoryBeans if the "allowEagerInit" flag is set, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type. If "allowEagerInit" is not set, only raw FactoryBeans will be checked (which doesn't require initialization of each FactoryBean).

  Does not consider any hierarchy this factory may participate in. Use BeanFactoryUtils' `beanNamesForTypeIncludingAncestors` to include beans in ancestor factories too.

  Note: Does not ignore singleton beans that have been registered by other means than bean definitions.

  Bean names returned by this method should always return bean names in the order of definition in the backend configuration, as far as possible.

  Parameters:
    `type` - the class or interface to match, or `null` for all bean names
    `includeNonSingletons` - whether to include prototype or scoped beans too or just singletons (also applies to FactoryBeans)
    `allowEagerInit` - whether to initialize lazy-init singletons and objects created by FactoryBeans (or by factory methods with a "factory-bean" reference) for the type check. Note that FactoryBeans need to be eagerly initialized to determine their type: So be aware that passing in "true" for this flag will initialize FactoryBeans and "factory-bean" references.
  Returns:
    the names of beans (or objects created by FactoryBeans) matching the given object type (including subclasses), or an empty array if none
  See Also:
    `FactoryBean.getObjectType()`, `BeanFactoryUtils.beanNamesForTypeIncludingAncestors(ListableBeanFactory, Class, boolean, boolean)`

### getBeansOfType

    <T> java.util.Map<java.lang.String,T> getBeansOfType(java.lang.Class<T> type)
                                                     throws BeansException

  Return the bean instances that match the given object type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.

  NOTE: This method introspects top-level beans only. It does not check nested beans which might match the specified type as well.

  Does consider objects created by FactoryBeans, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type.

  Does not consider any hierarchy this factory may participate in. Use BeanFactoryUtils' `beansOfTypeIncludingAncestors` to include beans in ancestor factories too.

  Note: Does not ignore singleton beans that have been registered by other means than bean definitions.

  This version of getBeansOfType matches all kinds of beans, be it singletons, prototypes, or FactoryBeans. In most implementations, the result will be the same as for `getBeansOfType(type, true, true)`.

  The Map returned by this method should always return bean names and corresponding bean instances in the order of definition in the backend configuration, as far as possible.

  Parameters:
    `type` - the class or interface to match, or `null` for all concrete beans
  Returns:
    a Map with the matching beans, containing the bean names as keys and the corresponding bean instances as values
  Throws:
    `BeansException` - if a bean could not be created
  Since:
    1.1.2
  See Also:
    `FactoryBean.getObjectType()`, `BeanFactoryUtils.beansOfTypeIncludingAncestors(ListableBeanFactory, Class)`

### getBeansOfType

    <T> java.util.Map<java.lang.String,T> getBeansOfType(java.lang.Class<T> type,
                                                         boolean includeNonSingletons,
                                                         boolean allowEagerInit)
                                                     throws BeansException

  Return the bean instances that match the given object type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.

  NOTE: This method introspects top-level beans only. It does not check nested beans which might match the specified type as well.

  Does consider objects created by FactoryBeans if the "allowEagerInit" flag is set, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type. If "allowEagerInit" is not set, only raw FactoryBeans will be checked (which doesn't require initialization of each FactoryBean).

  Does not consider any hierarchy this factory may participate in. Use BeanFactoryUtils' `beansOfTypeIncludingAncestors` to include beans in ancestor factories too.

  Note: Does not ignore singleton beans that have been registered by other means than bean definitions.

  The Map returned by this method should always return bean names and corresponding bean instances in the order of definition in the backend configuration, as far as possible.

  Parameters:
    `type` - the class or interface to match, or `null` for all concrete beans
    `includeNonSingletons` - whether to include prototype or scoped beans too or just singletons (also applies to FactoryBeans)
    `allowEagerInit` - whether to initialize lazy-init singletons and objects created by FactoryBeans (or by factory methods with a "factory-bean" reference) for the type check. Note that FactoryBeans need to be eagerly initialized to determine their type: So be aware that passing in "true" for this flag will initialize FactoryBeans and "factory-bean" references.
  Returns:
    a Map with the matching beans, containing the bean names as keys and the corresponding bean instances as values
  Throws:
    `BeansException` - if a bean could not be created
  See Also:
    `FactoryBean.getObjectType()`, `BeanFactoryUtils.beansOfTypeIncludingAncestors(ListableBeanFactory, Class, boolean, boolean)`

### getBeansWithAnnotation

    java.util.Map<java.lang.String,java.lang.Object> getBeansWithAnnotation(java.lang.Class<? extends java.lang.annotation.Annotation> annotationType)
                                                                            throws BeansException

  Find all beans whose `Class` has the supplied `Annotation` type.

  Parameters:
    `annotationType` - the type of annotation to look for
  Returns:
    a Map with the matching beans, containing the bean names as keys and the corresponding bean instances as values
  Throws:
    `BeansException` - if a bean could not be created

### findAnnotationOnBean

    <A extends java.lang.annotation.Annotation> A findAnnotationOnBean(java.lang.String beanName,
                                                                       java.lang.Class<A> annotationType)

  Find a `Annotation` of `annotationType` on the specified bean, traversing its interfaces and super classes if no annotation can be found on the given class itself.

  Parameters:
    `beanName` - the name of the bean to look for annotations on
    `annotationType` - the annotation class to look for
  Returns:
    the annotation of the given type found, or `null`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD